Attribute VB_Name = "Security_procedures_and_declarations"
Attribute VB_Description = "Security proceedures"
'This module contains the declarations relating to user access rights
'and the security proceedures used to access them

'Encryption variables
Public Const Dummy_char = ""
Public Const Cancelled_change_password = ""
Public Encrypt_character As String * 1

Public Cipher_code As Integer
Public Cipher_character As String * 1
Public Decrypt_character As String * 1
Public myArray() As Variant

Public Users As Recordset

Type User_info
    Name As String
    Session_ID As Long
    Licensed_to As String
    Number As Integer
    Time_in As Double
End Type

Public User_info As User_info

'Security checking option
Public Const Effect_restore_or_repair = True

'Task menu
Public Allow_Setup As Boolean
Public Allow_Borrow As Boolean
Public Allow_Return As Boolean
Public Allow_Request As Boolean
Public Allow_Search As Boolean

'Subscriber records
Public Allow_View_Current_Subscriber_recs As Boolean
Public Allow_Edit_Current_Subscriber_recs As Boolean
Public Allow_deregister_subscriber As Boolean

'Book records
Public Allow_View_Current_Bk_recs As Boolean
Public Allow_Edit_Current_Bk_recs As Boolean
Public Allow_deregister_books As Boolean

'Deregistered books
Public Allow_View_Deregistered_Bk_recs As Boolean

'Terminated subscriptions
Public Allow_View_Terminated_Subscriber_recs As Boolean

'Transaction records
Public Allow_view_Bk_log As Boolean
Public Allow_view_Subsc_log As Boolean
Public Allow_view_Main_log As Boolean
Public Allow_view_Security_log As Boolean

'Database management
Public Allow_Backup As Boolean
Public Allow_Restore As Boolean
Public Allow_Optimise As Boolean

'Report maker
Public Allow_Report_making As Boolean

'Querying
Public Allow_Querying As Boolean

'Access rights
Public Allow_Edit_access_rights As Boolean


Public Sub Initialise_security()

    If User_info.Number = 1 Then
        Initialise_user1
    Else
        Initialise_low_priority_user
    End If
    
End Sub

Private Sub Initialise_user1()
     Allow_Edit_access_rights = True
     Allow_Setup = True
     Allow_Borrow = True
     Allow_Return = True
     Allow_Request = True
     Allow_Search = True
    
    'Subscriber records
     Allow_View_Current_Subscriber_recs = True
     Allow_Edit_Current_Subscriber_recs = True
     Allow_deregister_subscriber = True
    
    'Book records
     Allow_View_Current_Bk_recs = True
     Allow_Edit_Current_Bk_recs = True
     Allow_deregister_books = True
    
    'Deregistered books
     Allow_View_Deregistered_Bk_recs = True
    
    'Terminated subscriptions
     Allow_View_Terminated_Subscriber_recs = True
    
    'Transaction records
     Allow_view_Bk_log = True
     Allow_view_Subsc_log = True
     Allow_view_Main_log = True
     Allow_view_Security_log = True
    
    'Database management
     Allow_Backup = True
     Allow_Restore = True
     Allow_Optimise = True
    
    'Report maker
     Allow_Report_making = True
    
    'Querying
     Allow_Querying = True

End Sub

Private Sub Initialise_low_priority_user()
    Dim User_string As String
    Dim Search_string As String
    
    If User_info.Number = 2 Then
        Search_string = "User 2 access rights"
    ElseIf User_info.Number = 3 Then
        Search_string = "User 3 access rights"
    End If
    
    User_string = Get_setup_data(Search_string, False)
    
    If User_string = "" Then
        msg$ = "Unable to locate access priviledges' settings."
        msg$ = msg$ + "Please refer to the person in charge of setting "
        msg$ = msg$ + "your access rights. "
        msg$ = msg$ + New_line + New_line
        msg$ = msg$ + "Librarius 2000 will now shut down."
        MsgBox msg$, vbCritical, "System Security"
        End
    Else
        Allow_Edit_access_rights = False
        Allow_Setup = Get_right(Mid(User_string, 1, 1))
        Allow_Borrow = Get_right(Mid(User_string, 2, 1))
        Allow_Return = Get_right(Mid(User_string, 3, 1))
        Allow_Request = Get_right(Mid(User_string, 4, 1))
        Allow_Search = Get_right(Mid(User_string, 5, 1))
        
        'Subscriber records
        Allow_View_Current_Subscriber_recs = Get_right(Mid(User_string, 6, 1))
        Allow_Edit_Current_Subscriber_recs = Get_right(Mid(User_string, 7, 1))
        Allow_deregister_subscriber = Get_right(Mid(User_string, 8, 1))
        
        'Book records
        Allow_View_Current_Bk_recs = Get_right(Mid(User_string, 9, 1))
        Allow_Edit_Current_Bk_recs = Get_right(Mid(User_string, 10, 1))
        Allow_deregister_books = Get_right(Mid(User_string, 11, 1))
        
        'Deregistered books
        Allow_View_Deregistered_Bk_recs = Get_right(Mid(User_string, 12, 1))
        
        'Terminated subscriptions
        Allow_View_Terminated_Subscriber_recs = Get_right(Mid(User_string, 13, 1))
        
        'Transaction records
        Allow_view_Main_log = Get_right(Mid(User_string, 14, 1))
        Allow_view_Subsc_log = Get_right(Mid(User_string, 15, 1))
        Allow_view_Bk_log = Get_right(Mid(User_string, 16, 1))
        Allow_view_Security_log = Get_right(Mid(User_string, 17, 1))
                 
        'Database management
        Allow_Backup = Get_right(Mid(User_string, 18, 1))
        Allow_Restore = Get_right(Mid(User_string, 19, 1))
        Allow_Optimise = Get_right(Mid(User_string, 20, 1))
                 
        'Report maker
        Allow_Report_making = Get_right(Mid(User_string, 21, 1))
        
        'Querying
        Allow_Querying = Get_right(Mid(User_string, 22, 1))
    End If
        

End Sub

Private Function Get_right(Permission_value As String) As Boolean

    If Permission_value = "1" Then
        Get_right = True
    Else
        Get_right = False
    End If
    
End Function

Public Sub Activate_security()
    
    Initialise_security
    With frmLibra2G
        .mnuBorrow.Enabled = Allow_Borrow
        .mnuSwap_Borrow.Enabled = Allow_Borrow
        .mnuReturn.Enabled = Allow_Return
        .mnuSwap_Return.Enabled = Allow_Return
        .mnuRequest.Enabled = Allow_Request
        .mnuSwap_Request.Enabled = Allow_Request
        .mnuSearch.Enabled = Allow_Search
        .mnuSwap_Search.Enabled = Allow_Search
        .mnuSetup.Enabled = Allow_Setup
        .mnuSubscribers.Enabled = Allow_View_Current_Subscriber_recs
        .mnuBooks.Enabled = Allow_View_Current_Bk_recs
        .mnuCancelled_subscriptions.Enabled = Allow_View_Deregistered_Bk_recs
        .mnuDeregistered_books.Enabled = Allow_View_Terminated_Subscriber_recs
    End With
    
    
    
    
End Sub

Public Sub Check_security(Optional Restore_or_repair_option)
    Dim Counter As Integer
    Dim Password As String
    Dim Verified As Boolean
    Dim Passed_Restore_or_repair As Boolean
    
    If IsMissing(Restore_or_repair_option) Then
        Passed_Restore_or_repair = False
    Else
        Passed_Restore_or_repair = Restore_or_repair_option
    End If
    
    If Passed_Restore_or_repair Then
        frmEnter_password.Caption = "Enter your Product ID Password"
    Else
        frmEnter_password.Caption = "Enter your User Password"
    End If

    
    For Counter = 1 To 2
        frmEnter_password.Show 1
        Password = frmEnter_password.txtPassword.Text
        If Password_verified(Password, Passed_Restore_or_repair) Then
            Verified = True
            Exit For
        Else
            If Counter = 1 Then
                msg$ = "Incorrect password. Try again"
                frmEnter_password.txtPassword.Text = ""
            Else
                msg$ = "You have violated system security. You are now "
                msg$ = msg$ + "being forced to exit."
            End If
            MsgBox msg$, vbCritical, "System Security"
        End If
    Next
    
    Unload frmEnter_password
    If Not (Verified) Then
        End
    End If
    
    
End Sub

Private Function Password_verified(Password As String, Restore_or_repair As Boolean) As Boolean
    Dim Temp_password As String
    
    If Restore_or_repair Then
        'The restore_repair password is hard coded as it might become necessary to
        'restore or repair an inaccessible database.
        
        If UCase(Password) = "LIBRA 25081982" Then
            Password_verified = True
        Else
            Password_verified = False
        End If
    Else
        Temp_password = Get_setup_data("User 1 password", False)
        
        If Temp_password = "" Then
            msg$ = "Unable to determine User 1. Please refer to the manual"
            MsgBox msg$, vbCritical, "Security Failiure : Aborting "
            End
        Else
            If UCase(Password) = UCase(Temp_password) Then
                User_info.Number = 1
                Set_user_name ("User 1")
                Password_verified = True
                Exit Function
            End If
        End If
        
        Temp_password = Get_setup_data("User 2 password", False)
        If Temp_password <> "" Then
            If UCase(Password) = UCase(Temp_password) Then
                User_info.Number = 2
                Set_user_name ("User 2")
                Password_verified = True
                Exit Function
            End If
        End If
                
        Temp_password = Get_setup_data("User 3 password", False)
        If Temp_password <> "" Then
            If UCase(Password) = UCase(Temp_password) Then
                User_info.Number = 3
                Set_user_name ("User 3")
                Password_verified = True
                Exit Function
            End If
        End If
        
        'If this part of the proceedure is run then the
        'password was incorrect.
        
        Password_verified = False
    End If
        
End Function

Public Sub Set_user_name(myUser As String)
    
    Dim Search_string As String
    Dim Temp_name As String
    
    Search_string = myUser + " name"
    Temp_name = Get_setup_data(Search_string, False)
    
    If Temp_name = "" Then
        msg$ = "Librarius could not determine " + myUser + "'s name."
        msg$ = msg$ + New_line + "Please have it set using setup."
        MsgBox msg$, vbCritical, "User Name Not Found : Aborting"
        End
    Else
        User_info.Name = Temp_name
    End If
    
End Sub

Public Sub Log_in_user(Area_ID As Integer)
    
    User_log.AddNew
        User_log("time in") = Now
        User_log("user name") = User_info.Name
        User_log("area") = Area_ID
    User_log.Update
    
    User_log.Bookmark = User_log.LastModified
    User_info.Session_ID = User_log("Session")
    
    User_info.Licensed_to = Get_setup_data("Licensed to", True)
    
End Sub

Public Sub Activate_transaction_security()
    
    New_line = Chr(13) + Chr(10)
    Initialise_security
    
    With frmTransactions
        .mnuBooks_log.Enabled = Allow_view_Bk_log
        .mnuSubscribers_log.Enabled = Allow_view_Subsc_log
        .mnuMain_log.Enabled = Allow_view_Main_log
        .mnuUsers_log.Enabled = Allow_view_Security_log
    End With
    
End Sub

Public Sub Log_out_user()
    Set User_log = Transaction_db.OpenRecordset("user's log")
    User_log.Index = "User log index"
    User_log.Seek "=", User_info.Session_ID
    
    If Not (User_log.NoMatch) Then
        User_log.Edit
            User_log("time out") = Now
        User_log.Update
    End If
    
End Sub

Public Function Encrypt(Plain_text As String) As String
    Build_array
    Cipher_text = ""
    
    For Counter = 1 To Len(Plain_text)
        Encrypt_character = myArray(1 + (Counter Mod 51))
        Character = Mid(Plain_text, Counter, 1)
        Cipher_code = Asc(Encrypt_character) + Asc(Character)
        Cipher_character = Chr((Cipher_code Mod 95) + 32)
        Cipher_text = Cipher_text + Cipher_character
    Next
    Encrypt = Dummy_char + Cipher_text + Dummy_char
    
End Function

Public Function Decrypt(Cipher_text As String) As String
    Build_array
    Plain_text = ""
    If Len(Cipher_text) <= 2 Then
        Cipher_text = ""
    Else
        Cipher_text = Mid(Cipher_text, 2, Len(Cipher_text) - 2)
    End If
    For Counter = 1 To Len(Cipher_text)
        Cipher_character = Mid(Cipher_text, Counter, 1)
        Decrypt_character = myArray(1 + (Counter Mod 51))
        Cipher_code = Asc(Cipher_character) - 32 - Asc(Decrypt_character)
        If Cipher_code < 0 Then
            Cipher_code = Cipher_code + 95
        End If
        
        If Cipher_code < 32 Then
            Cipher_code = Cipher_code + 95
        End If
        Plain_text = Plain_text + Chr(Cipher_code)
    Next
    Decrypt = Plain_text

End Function


Private Sub Build_array()
    Dim Source_text As String
    
    Source_text = "MOMMY,DAD,REGINA,RUSSELL,ROSELYN,TINOVIMBA,RUTENDO."
    
    ReDim myArray(1 To 51)
    For X = 1 To 51
        myArray(X) = Mid(Source_text, X, 1)
    Next
    
End Sub

