Attribute VB_Name = "Borrow_Return_Requests_procedures"
Attribute VB_Description = "Transactions' Library"

'This module contains the routines shared by the Task Menu
'modules.

Public Function FindSubscriberDetails(Subscriber As String) As String
    
    Dim mySQL As String
    Dim Temp As Double
    Dim myTemp As String
    
    Dim Number_borrowed As Integer
    Dim Number_borrowed_and_overdue As Integer
    Dim Number_requested As Integer
    Dim Number_requested_and_expired As Integer
    Dim BorrowingLimit As Integer
    Dim RequisitionLimit As Integer
    
    Screen.ActiveForm.MousePointer = 11
    Subscribers.Index = "subscriberid index"
    Subscribers.Seek "=", Subscriber
    If Subscribers.NoMatch Then
        FindSubscriberDetails = ""
    Else
        nameo$ = Subscribers("subscriber title") + " " + Subscribers("initials") + " "
        nameo$ = nameo$ + Subscribers("surname")
        
        Expires$ = Format$(Subscribers("expiry date"), DateFormat)
        Number_borrowed = Get_number_borrowed(Subscriber)
        Number_borrowed_and_overdue = Get_number_borrowed_and_overdue(Subscriber)
        Number_requested = Get_number_requested(Subscriber)
        Number_requested_and_expired = Get_number_requested_and_expired(Subscriber)
        BorrowingLimit = Get_borrowing_limit(Subscriber, Number_requested)
        RequisitionLimit = Get_requisition_limit(Subscriber, Number_borrowed)
        
        'Output details
        
        myTemp = ""
        myTemp = myTemp + "Name" + Tabs(2) + nameo$ + New_line
        myTemp = myTemp + "Expires" + Tabs(2) + Expires$ + New_line
        myTemp = myTemp + "Borrowed" + Tabs(2) + Trim(Str(Number_borrowed))
        myTemp = myTemp + " (#" + Str(Number_borrowed_and_overdue) + " )"
        myTemp = myTemp + New_line
        myTemp = myTemp + "Can Borrow" + Tabs(1) + Trim(Str(BorrowingLimit - Number_borrowed))
        myTemp = myTemp + New_line
        myTemp = myTemp + "Requested" + Tabs(1) + Trim(Str(Number_requested))
        myTemp = myTemp + " (# " + Str$(number_requested_and_exired) + " )"
        myTemp = myTemp + New_line
        myTemp = myTemp + "Can Request" + Tabs(1) + Trim(Str$(RequisitionLimit - Number_requested))
        
        FindSubscriberDetails = myTemp
    End If
    Screen.ActiveForm.MousePointer = 0
End Function


Public Function Get_number_borrowed(Subscriber As String) As Integer
    'Get number loaned to subscriber
    mySQL = "Parameters [subscriber IDnum] Text;" _
            & "Select count(*) as [number Borrowed]  " _
            & "From [books borrowed table] " _
            & "Where [subscriber id] = [Subscriber IDnum];"
                
    
    Query.SQL = mySQL
    Query.Parameters("Subscriber IDnum") = Subscriber
    
    Set Temp_recordset = Query.OpenRecordset()
    Get_number_borrowed = Temp_recordset("number Borrowed")
    
    
    
End Function

Public Function Get_number_borrowed_and_overdue(Subscriber) As Integer
    'Get number overdue
    mySQL = "Parameters [Subscriber IDnum] Text," _
            & "         [myDate] Datetime ;" _
            & " Select count(*) as [Books overdue]" _
            & " From [books borrowed table] " _
            & " Where ([date due] < [myDate] ) and " _
            & "([subscriber id] = [Subscriber IDnum]) "
            
    Query.SQL = mySQL
    Query.Parameters![myDate] = Date
    Query.Parameters![Subscriber IDnum] = Subscriber
    Set Temp_recordset = Query.OpenRecordset()
    
    Get_number_borrowed_and_overdue = Temp_recordset("Books overdue")
    
End Function

Public Function Get_number_requested(Subscriber) As Integer

        'Get number requested by subscriber
        mySQL = "PARAMETERS [Subscriber IDnum] Text; " _
                & "SELECT Count(*) as [Number Requested] " _
                & "From [books requested table]" _
                & "Where [subscriber id] = [Subscriber IDnum];"
        
        Query.SQL = mySQL
        Query.Parameters![Subscriber IDnum] = Subscriber
        Set Temp_recordset = Query.OpenRecordset()
        Get_number_requested = Temp_recordset("number requested")

End Function

Public Function Get_number_requested_and_expired(Subscriber) As Integer

        'Get number overdue
        mySQL = "Parameters [subscriber IDnum] Text," _
                & "         [myDate] DateTime;" _
                & "Select count(*) as [Requested and expired] " _
                & "From [books requested table]" _
                & "Where ([subscriber id] = [subscriber IDnum]) " _
                & " and ([expiry date] < myDate ) "
                
        Query.SQL = mySQL
        Query.Parameters("Subscriber IDnum") = Subscriber
        Query.Parameters("myDate") = Date
        Set Temp_recordset = Query.OpenRecordset()
        Get_number_requested_and_expired = Temp_recordset("Requested and expired")
        
End Function

Public Function Get_borrowing_limit(Subscriber As String, _
                                    Number_requested As Integer) As Integer
    Dim BorrowingLimit As Integer
    'Get Borrowing limit
    
    Subscribers.Index = "subscriberid index"
    Subscribers.Seek "=", Subscriber
    If Subscribers.NoMatch Then
        msg$ = "Unable to determine limit. Subscriber not found"
        buttons = vbOKOnly + vbExclamation
        MsgBox msg$, buttons, "Borrowing Limit"
        Exit Function
    End If
    
    limit_as_to = Val(Get_setup_data("borrowing limit as to", True))
    Select Case limit_as_to
        Case 1
            BorrowingLimit = Val(Get_setup_data("fixed borrowing limit", True))
        Case 2
            BorrowingLimit = Subscribers("Borrowing limit")
        Case 3
            Temp = Val(Get_setup_data("fixed borrowing limit", True))
            BorrowingLimit = Temp - Number_requested
        Case 4
            Temp = Subscribers("Borrowing limit")
            BorrowingLimit = Temp - Number_requested
    End Select
    
    If BorrowingLimit < 0 Then
        Get_borrowing_limit = 0
        If BorrowingLimit = -1 Then
            myString$ = " book."
        Else
            myString$ = " books."
        End If
        msg$ = "The subscriber has exceded his/her borrowing limit "
        msg$ = msg$ + "by " + Str(Abs(BorrowingLimit)) + myString$
        MsgBox msg$, vbCritical, "Subscriber Details"
    Else
        Get_borrowing_limit = BorrowingLimit
    End If
    
End Function

Public Function Get_requisition_limit(Subscriber As String, _
                                      Number_borrowed As Integer) As Integer
    'Get Requisition limit
    limit_as_to = Val(Get_setup_data("request limit as to", True))
    Select Case limit_as_to
        Case 1
            Requisition_limit = Val(Get_setup_data("fixed requisition limit", True))
        Case 2
            Temp = Val(Get_setup_data("fixed requisition limit", True))
            Requisition_limit = Temp - Number_borrowed
    End Select
    
    If Requisition_limit < 0 Then
        Get_requisition_limit = 0
        If Requisition_limit = -1 Then
            myString$ = " book."
        Else
            myString$ = " books."
        End If
        msg$ = "The subscriber has exceded his/her requisition limit "
        msg$ = msg$ + "by " + Str(Abs(Requisition_limit)) + myString$
        MsgBox msg$, vbCritical, "Subscriber Details"
    Else
        Get_requisition_limit = Requisition_limit
    End If

    Get_requisition_limit = Requisition_limit
    
End Function

Public Function Check_expiry(Subscriber As String) As Boolean
    
    Subscribers.Index = "subscriberid index"
    Subscribers.Seek "=", Subscriber
    If Subscribers.NoMatch Then
        msg$ = "Unable to determine whether the subscription has expired or not."
        buttons = vbOKOnly + vbExclamation
        MsgBox msg$, buttons, "Subscription Expiry"
        Check_expiry = False
        
    Else
        If Subscribers("expiry date") < Date Then
            msg$ = "This subscription has expired"
            buttons = vbOKOnly + vbExclamation
            MsgBox msg$, buttons, "Subscription Expiry"
            Check_expiry = False
        Else
            Check_expiry = True
        End If
    End If
    
End Function

Public Function Format_amount(Amount As Long) As Currency
    'Format amount into $ format from cents only format
    
    Dim Temp_amount As String
    Dim Cents_part As String
    Dim Dollars_part As String
    
    Temp_amount = Trim(Str$(Amount))
    Cents_part$ = Right(Temp_amount, 2)
    If Len(Temp_amount) > 2 Then
        Dollars_part$ = Left(Temp_amount, Len(Temp_amount$) - 2)
    End If
    Format_amount = Val(Dollars_part$ + "." + Cents_part$)
    
End Function

Public Sub Get_subscriber_details(Title As String)
    Dim myForm As Form
    Set myForm = Screen.ActiveForm
    
    If Not (validate_subscriberID(myForm.txtSubscriberID)) Then
        Exit Sub
    Else
        details$ = FindSubscriberDetails(myForm.txtSubscriberID.Text)
        If details$ = "" Then
            msg$ = "Invalid subscriber Id code."
            buttons = vbExclamation + vbOKOnly
            MsgBox msg$, butttons, Title
            myForm.txtSubscriberID.SetFocus
            Exit Sub
        Else
            myForm.txtDetails.Text = details$
            KeyAscii = 0
            myForm.txtBooks.SetFocus
        End If
    End If

End Sub
